| API Documentation |  |

- MAIN PAGE
- NAMESPACES
- CLASSES

Classes | Enumerations | Functions
nkMemory Namespace Reference

Encompasses all API of component NilkinsMemory. More...

## Classes
class | Allocator
| Interface representing an allocator, supposed to allocate an object when requested. More...
class | BitStream
| Offers capabilities to read data bit per bit. More...
class | Buffer
| A buffer holding binary data. More...
class | BufferCast
| Holds a Buffer and make it easy to cast the binary data. More...
struct | BufferDataDescriptor
| Describes the data held by a buffer. More...
class | BufferView
| A view over data. More...
class | Deallocator
| Interface used for deallocating memory. More...
class | DefaultAllocator
| A utility default allocator allocating an object through a simple call to new. More...
class | DefaultDeallocator
| A utility default deallocator using a simple call to delete. More...
class | DefaultMemorySpace
| A basic memory space with default implementation. More...
class | DefaultMemorySpaceAllocator
| A default memory space allocator, offering the most basic memory allocation method. More...
class | DeflateEncoder
| An encoder supporting Inflate/Deflate compression. More...
struct | DeflateOutputStorage
| Used internally to keep track of the output buffer status. More...
struct | FreeListAllocation
| Holds information about an allocation returned by the pager. More...
class | FreeListPager
| A pager implementing the free list pattern. More...
class | HuffmanLut
| Allows to create a Look-Up-Table (LUT) of a Huffman tree. More...
struct | HuffmanSymbol
| Holds a symbol's information within the Huffman LUT. More...
struct | HuffmanTreeDescriptor
| Descriptor for a Huffman LUT creation. More...
class | LinearPager
| A pager using a linear allocation algorithm. More...
class | LogManager
| Responsible for logging all messages from the component. More...
class | MemorySpace
| Represents a memory space held by a page in a pager. More...
class | MemorySpaceAllocator
| Defines the interface for a memory space allocator, to be used within the pagers. More...
class | PtrPool
| A pool of objects, allocated in the heap and tracked by their pointers. More...
class | String
| Class holding information about a string, with ownership over the data. More...
class | StringView
| Class holding information about a string, with no ownership over the data. More...
class | UniquePtr
| Smart pointer owning the object instance it encapsulates. More...

## Enumerations
enum | DEFLATE_BLOCK_TYPE
| Used internally to keep track of the current block type.

## Functions
bool | operator== (const char *c, const nkMemory::String &str)
nkMemory::String | operator+ (char c, const nkMemory::String &str)
nkMemory::String | operator+ (const char *c, const nkMemory::String &str)
bool | operator== (const char *c, const nkMemory::StringView &str)

## Detailed Description

Encompasses all API of component NilkinsMemory.

Defines / Macros ----------------------—.

This component offers memory management algorithms, such as :

- Paging of memory through the nkMemory::LinearPager or nkMemory::FreeListPager
- Pooling of objects through nkMemory::PtrPool

By using this component, improve your memory allocation times by avoiding the low level system calls. On top of that, it offers high flexibility through the use of memory spaces and custom allocations. Customize the nkMemory::MemorySpace used by the pagers and allocate the memory where it is required. Choose how a nkMemory::Allocator should act to fully drive a pool.

Includes ------------------------------— Class ---------------------------------—

## Function Documentation

## ◆ operator==() [1/2]

bool nkMemory::operator== | ( | const char * | c,
|  | const nkMemory::String & | str
| ) |  |
| inline

Equality operator between a char chain and a string.

Parameters

  c | The chain to compare.
  str | The string to compare with.

Returns
  True if both chains are the same, false otherwise.

## ◆ operator+() [1/2]

nkMemory::String nkMemory::operator+ | ( | char | c,
|  | const nkMemory::String & | str
| ) |  |
| inline

Concatenation operator between a char and a string.

Parameters

  c | The char to concatenate.
  str | The string to concatenate.

Returns
  The result of concatenation of the char with the string.

## ◆ operator+() [2/2]

nkMemory::String nkMemory::operator+ | ( | const char * | c,
|  | const nkMemory::String & | str
| ) |  |
| inline

Concatenation operator between a char chain and a string.

Parameters

  c | The char chain to concatenate.
  str | The string to concatenate.

Returns
  The result of concatenation of the char chain with the string.

## ◆ operator==() [2/2]

bool nkMemory::operator== | ( | const char * | c,
|  | const nkMemory::StringView & | str
| ) |  |
| inline

Equality operator between a char chain and a view.

Parameters

  c | The chain to compare.
  str | The view to compare with.

Returns
  True if both chains are the same, false otherwise.